(function(){var P$=Clazz.newPackage("jalview.ext.ensembl"),I$=[[0,'java.util.Arrays','jalview.ext.ensembl.EnsemblFeatures','jalview.ext.ensembl.EnsemblProtein','jalview.analysis.AlignmentUtils','jalview.datamodel.Mapping','jalview.datamodel.DBRefEntry','jalview.util.DBRefUtils','jalview.bin.Cache','jalview.ext.ensembl.EnsemblXref','jalview.io.FastaFile','jalview.datamodel.Alignment','StringBuffer','java.net.URL','java.util.ArrayList','java.util.Collections','jalview.util.IntRangeComparator','jalview.util.MapList','jalview.datamodel.SequenceFeature','jalview.io.gff.SequenceOntologyFactory','StringBuilder','jalview.util.Comparison','jalview.analysis.Dna','jalview.datamodel.features.SequenceFeatures']],$I$=function(i){return I$[i]||(I$[i]=Clazz.load(I$[0][i]))};
var C$=Clazz.newClass(P$, "EnsemblSeqProxy", function(){
Clazz.newInstance(this, arguments,0,C$);
}, 'jalview.ext.ensembl.EnsemblRestClient');

C$.$clinit$ = function() {Clazz.load(C$, 1);
}

Clazz.newMeth(C$, '$init$', function () {
}, 1);

Clazz.newMeth(C$, 'c$', function () {
C$.superclazz.c$.apply(this, []);
C$.$init$.apply(this);
}, 1);

Clazz.newMeth(C$, 'c$$S', function (d) {
C$.superclazz.c$$S.apply(this, [d]);
C$.$init$.apply(this);
}, 1);

Clazz.newMeth(C$, 'getSequenceRecords$S', function (query) {
var allIds=Clazz.load('java.util.Arrays').asList$TTA(query.split$S(this.getAccessionSeparator$()));
var alignment=null;
this.inProgress=true;
var maxQueryCount=this.getMaximumQueryCount$();
for (var v=0, vSize=allIds.size$(); v < vSize; v+=maxQueryCount) {
var p=Math.min(vSize, v + maxQueryCount);
var ids=allIds.subList$I$I(v, p);
try {
alignment=this.fetchSequences$java_util_List$jalview_datamodel_AlignmentI(ids, alignment);
} catch (r) {
this.inProgress=false;
var msg="Aborting ID retrieval after " + v + " chunks. Unexpected problem (" + r.getLocalizedMessage$() + ")" ;
System.err.println$S(msg);
r.printStackTrace$();
break;
}
}
if (alignment == null ) {
return null;
}for (var accId, $accId = allIds.iterator$(); $accId.hasNext$()&&((accId=($accId.next$())),1);) {
this.addFeaturesAndProduct$S$jalview_datamodel_AlignmentI(accId, alignment);
}
for (var seq, $seq = alignment.getSequences$().iterator$(); $seq.hasNext$()&&((seq=($seq.next$())),1);) {
this.getCrossReferences$jalview_datamodel_SequenceI(seq);
}
return alignment;
});

Clazz.newMeth(C$, 'addFeaturesAndProduct$S$jalview_datamodel_AlignmentI', function (accId, alignment) {
if (alignment == null ) {
return;
}try {
var genomicSequence=null;
var gffFetcher=Clazz.new_(Clazz.load('jalview.ext.ensembl.EnsemblFeatures').c$$S,[this.getDomain$()]);
var features=this.getFeaturesToFetch$();
var geneFeatures=gffFetcher.getSequenceRecords$S$jalview_ext_ensembl_EnsemblSequenceFetcher_EnsemblFeatureTypeA(accId, features);
if (geneFeatures != null  && geneFeatures.getHeight$() > 0 ) {
genomicSequence=geneFeatures.getSequenceAt$I(0);
}if (genomicSequence != null ) {
var querySeq=alignment.findName$S$Z(accId, true);
if (this.transferFeatures$S$jalview_datamodel_SequenceI$jalview_datamodel_SequenceI(accId, genomicSequence, querySeq)) {
this.addProteinProduct$jalview_datamodel_SequenceI(querySeq);
}}} catch (e) {
if (Clazz.exceptionOf(e,"java.io.IOException")){
System.err.println$S("Error transferring Ensembl features: " + e.getMessage$());
} else {
throw e;
}
}
});

Clazz.newMeth(C$, 'addProteinProduct$jalview_datamodel_SequenceI', function (querySeq) {
var accId=querySeq.getName$();
try {
var protein=Clazz.new_(Clazz.load('jalview.ext.ensembl.EnsemblProtein').c$$S,[this.getDomain$()]).getSequenceRecords$S(accId);
if (protein == null  || protein.getHeight$() == 0 ) {
System.out.println$S("No protein product found for " + accId);
return;
}var proteinSeq=protein.getSequenceAt$I(0);
proteinSeq.createDatasetSequence$();
querySeq.createDatasetSequence$();
var mapList=Clazz.load('jalview.analysis.AlignmentUtils').mapCdsToProtein$jalview_datamodel_SequenceI$jalview_datamodel_SequenceI(querySeq, proteinSeq);
if (mapList != null ) {
var ds=proteinSeq.getDatasetSequence$();
var map=Clazz.new_(Clazz.load('jalview.datamodel.Mapping').c$$jalview_datamodel_SequenceI$jalview_util_MapList,[ds, mapList]);
var dbr=Clazz.new_(Clazz.load('jalview.datamodel.DBRefEntry').c$$S$S$S$jalview_datamodel_Mapping,[this.getDbSource$(), this.getEnsemblDataVersion$(), proteinSeq.getName$(), map]);
querySeq.getDatasetSequence$().addDBRef$jalview_datamodel_DBRefEntry(dbr);
var uprots=Clazz.load('jalview.util.DBRefUtils').selectRefs$jalview_datamodel_DBRefEntryA$SA(ds.getDBRefs$(), Clazz.array(String, -1, ["UNIPROT"]));
var upxrefs=$I$(7).selectRefs$jalview_datamodel_DBRefEntryA$SA(querySeq.getDBRefs$(), Clazz.array(String, -1, ["UNIPROT"]));
if (uprots != null ) {
for (var up, $up = 0, $$up = uprots; $up<$$up.length&&((up=($$up[$up])),1);$up++) {
var upx=$I$(7).searchRefs$jalview_datamodel_DBRefEntryA$S(upxrefs, up.getAccessionId$());
var upxref;
if (upx.size$() != 0) {
upxref=upx.get$I(0);
if (upx.size$() > 1) {
Clazz.load('jalview.bin.Cache').log.warn$O("Implementation issue - multiple uniprot acc on product sequence.");
}} else {
upxref=Clazz.new_($I$(6).c$$S$S$S,["UNIPROT", this.getEnsemblDataVersion$(), up.getAccessionId$()]);
}var newMap=Clazz.new_($I$(5).c$$jalview_datamodel_SequenceI$jalview_util_MapList,[ds, mapList]);
upxref.setVersion$S(this.getEnsemblDataVersion$());
upxref.setMap$jalview_datamodel_Mapping(newMap);
if (upx.size$() == 0) {
querySeq.getDatasetSequence$().addDBRef$jalview_datamodel_DBRefEntry(upxref);
}}
}$I$(4).computeProteinFeatures$jalview_datamodel_SequenceI$jalview_datamodel_SequenceI$jalview_util_MapList(querySeq, proteinSeq, mapList);
}} catch (e) {
if (Clazz.exceptionOf(e,"Exception")){
System.err.println$S(String.format$S$OA("Error retrieving protein for %s: %s", [accId, e.getMessage$()]));
} else {
throw e;
}
}
});

Clazz.newMeth(C$, 'getCrossReferences$jalview_datamodel_SequenceI', function (seq) {
while (seq.getDatasetSequence$() != null ){
seq=seq.getDatasetSequence$();
}
var xrefFetcher=Clazz.new_(Clazz.load('jalview.ext.ensembl.EnsemblXref').c$$S$S$S,[this.getDomain$(), this.getDbSource$(), this.getEnsemblDataVersion$()]);
var xrefs=xrefFetcher.getCrossReferences$S(seq.getName$());
for (var xref, $xref = xrefs.iterator$(); $xref.hasNext$()&&((xref=($xref.next$())),1);) {
seq.addDBRef$jalview_datamodel_DBRefEntry(xref);
}
var self=Clazz.new_($I$(6).c$$S$S$S,[this.getDbSource$(), this.getEnsemblDataVersion$(), seq.getName$()]);
seq.addDBRef$jalview_datamodel_DBRefEntry(self);
});

Clazz.newMeth(C$, 'fetchSequences$java_util_List$jalview_datamodel_AlignmentI', function (ids, alignment) {
if (!this.isEnsemblAvailable$()) {
this.inProgress=false;
throw Clazz.new_(Clazz.load('jalview.exceptions.JalviewException').c$$S,["ENSEMBL Rest API not available."]);
}var fp=this.getSequenceReader$java_util_List(ids);
if (fp == null ) {
return alignment;
}var fr=Clazz.new_(Clazz.load('jalview.io.FastaFile').c$$jalview_io_FileParse,[fp]);
if (fr.hasWarningMessage$()) {
System.out.println$S(String.format$S$OA("Warning when retrieving %d ids %s\n%s", [new Integer(ids.size$()), ids.toString(), fr.getWarningMessage$()]));
} else if (fr.getSeqs$().size$() != ids.size$()) {
System.out.println$S(String.format$S$OA("Only retrieved %d sequences for %d query strings", [new Integer(fr.getSeqs$().size$()), new Integer(ids.size$())]));
}if (fr.getSeqs$().size$() == 1 && fr.getSeqs$().get$I(0).getLength$() == 0 ) {
throw Clazz.new_(Clazz.load('java.io.IOException').c$$S,["No data returned for " + ids]);
}if (fr.getSeqs$().size$() > 0) {
var seqal=Clazz.new_(Clazz.load('jalview.datamodel.Alignment').c$$jalview_datamodel_SequenceIA,[fr.getSeqsAsArray$()]);
for (var sq, $sq = seqal.getSequences$().iterator$(); $sq.hasNext$()&&((sq=($sq.next$())),1);) {
if (sq.getDescription$() == null ) {
sq.setDescription$S(this.getDbName$());
}var name=sq.getName$();
if (ids.contains$O(name) || ids.contains$O(name.replace$CharSequence$CharSequence("ENSP", "ENST")) ) {
var dbref=$I$(7).parseToDbRef$jalview_datamodel_SequenceI$S$S$S(sq, this.getDbSource$(), this.getEnsemblDataVersion$(), name);
sq.addDBRef$jalview_datamodel_DBRefEntry(dbref);
}}
if (alignment == null ) {
alignment=seqal;
} else {
alignment.append$jalview_datamodel_AlignmentI(seqal);
}}return alignment;
});

Clazz.newMeth(C$, 'getUrl$java_util_List', function (ids) {
var urlstring=Clazz.new_(Clazz.load('StringBuffer').c$$I,[128]);
urlstring.append$S(this.getDomain$() + "/sequence/id");
if (ids.size$() == 1) {
urlstring.append$S("/").append$S(ids.get$I(0));
}urlstring.append$S("?type=").append$S(this.getSourceEnsemblType$().getType$());
urlstring.append$S(("&Accept=text/x-fasta"));
var objectType=this.getObjectType$();
if (objectType != null ) {
urlstring.append$S("&").append$S("object_type").append$S("=").append$S(objectType);
}var url=Clazz.new_(Clazz.load('java.net.URL').c$$S,[urlstring.toString()]);
return url;
});

Clazz.newMeth(C$, 'getObjectType$', function () {
return null;
});

Clazz.newMeth(C$, 'getMaximumQueryCount$', function () {
return 50;
});

Clazz.newMeth(C$, 'useGetRequest$', function () {
return false;
});

Clazz.newMeth(C$, 'getRequestMimeType$Z', function (multipleIds) {
return multipleIds ? "application/json" : "text/x-fasta";
});

Clazz.newMeth(C$, 'getResponseMimeType$', function () {
return "text/x-fasta";
});

Clazz.newMeth(C$, 'getGenomicRangesFromFeatures$jalview_datamodel_SequenceI$S$I', function (sourceSequence, accId, start) {
var sfs=sourceSequence.getFeatures$().getPositionalFeatures$SA([]);
if (sfs.isEmpty$()) {
return null;
}var regions=Clazz.new_(Clazz.load('java.util.ArrayList').c$$I,[100]);
var mappedLength=0;
var direction=1;
var directionSet=false;
for (var sf, $sf = sfs.iterator$(); $sf.hasNext$()&&((sf=($sf.next$())),1);) {
if (this.identifiesSequence$jalview_datamodel_SequenceFeature$S(sf, accId)) {
var strand=sf.getStrand$();
strand=strand == 0 ? 1 : strand;
if (directionSet && strand != direction ) {
System.err.println$S("Error: forward and backward strand for " + accId);
return null;
}direction=strand;
directionSet=true;
if (strand < 0) {
regions.add$I$TE(0, Clazz.array(Integer.TYPE, -1, [sf.getEnd$(), sf.getBegin$()]));
} else {
regions.add$TE(Clazz.array(Integer.TYPE, -1, [sf.getBegin$(), sf.getEnd$()]));
}mappedLength+=Math.abs(sf.getEnd$() - sf.getBegin$() + 1);
if (!this.isSpliceable$()) {
break;
}}}
if (regions.isEmpty$()) {
System.out.println$S("Failed to identify target sequence for " + accId + " from genomic features" );
return null;
}Clazz.load('java.util.Collections').sort$java_util_List$java_util_Comparator(regions, direction == 1 ? Clazz.load('jalview.util.IntRangeComparator').ASCENDING : $I$(16).DESCENDING);
var to=$I$(1).asList$TTA([Clazz.array(Integer.TYPE, -1, [start, start + mappedLength - 1])]);
return Clazz.new_(Clazz.load('jalview.util.MapList').c$$java_util_List$java_util_List$I$I,[regions, to, 1, 1]);
});

Clazz.newMeth(C$, 'isSpliceable$', function () {
return true;
});

Clazz.newMeth(C$, 'transferFeature$jalview_datamodel_SequenceFeature$jalview_datamodel_SequenceI$jalview_util_MapList$Z', function (sf, targetSequence, mapping, forwardStrand) {
var start=sf.getBegin$();
var end=sf.getEnd$();
var mappedRange=mapping.locateInTo$I$I(start, end);
if (mappedRange != null ) {
var group=sf.getFeatureGroup$();
if (".".equals$O(group)) {
group=this.getDbSource$();
}var newBegin=Math.min(mappedRange[0], mappedRange[1]);
var newEnd=Math.max(mappedRange[0], mappedRange[1]);
var copy=Clazz.new_(Clazz.load('jalview.datamodel.SequenceFeature').c$$jalview_datamodel_SequenceFeature$I$I$S$F,[sf, newBegin, newEnd, group, sf.getScore$()]);
targetSequence.addSequenceFeature$jalview_datamodel_SequenceFeature(copy);
if (!forwardStrand && Clazz.load('jalview.io.gff.SequenceOntologyFactory').getInstance$().isA$S$S(sf.getType$(), "sequence_variant") ) {
C$.reverseComplementAlleles$jalview_datamodel_SequenceFeature(copy);
}}});

Clazz.newMeth(C$, 'reverseComplementAlleles$jalview_datamodel_SequenceFeature', function (sf) {
var alleles=sf.getValue$S("alleles");
if (alleles == null ) {
return;
}var complement=Clazz.new_(Clazz.load('StringBuilder').c$$I,[alleles.length$()]);
for (var allele, $allele = 0, $$allele = alleles.split$S(","); $allele<$$allele.length&&((allele=($$allele[$allele])),1);$allele++) {
C$.reverseComplementAllele$StringBuilder$S(complement, allele);
}
var comp=complement.toString();
sf.setValue$S$O("alleles", comp);
sf.setDescription$S(comp);
var atts=sf.getAttributes$();
if (atts != null ) {
atts=atts.replace$CharSequence$CharSequence("alleles" + "=" + alleles , "alleles" + "=" + comp );
sf.setAttributes$S(atts);
}}, 1);

Clazz.newMeth(C$, 'reverseComplementAllele$StringBuilder$S', function (complement, allele) {
if (complement.length$() > 0) {
complement.append$S(",");
}if (!Clazz.load('jalview.util.Comparison').isNucleotideSequence$S$Z(allele, true)) {
complement.append$S(allele);
} else {
for (var i=allele.length$() - 1; i >= 0; i--) {
complement.append$C(Clazz.load('jalview.analysis.Dna').getComplement$C(allele.charAt$I(i)));
}
}}, 1);

Clazz.newMeth(C$, 'transferFeatures$S$jalview_datamodel_SequenceI$jalview_datamodel_SequenceI', function (accessionId, sourceSequence, targetSequence) {
if (sourceSequence == null  || targetSequence == null  ) {
return false;
}var sfs=sourceSequence.getFeatures$().getPositionalFeatures$SA([]);
var mapping=this.getGenomicRangesFromFeatures$jalview_datamodel_SequenceI$S$I(sourceSequence, accessionId, targetSequence.getStart$());
if (mapping == null ) {
return false;
}var result=this.transferFeatures$java_util_List$jalview_datamodel_SequenceI$jalview_util_MapList$S(sfs, targetSequence, mapping, accessionId);
return result;
});

Clazz.newMeth(C$, 'transferFeatures$java_util_List$jalview_datamodel_SequenceI$jalview_util_MapList$S', function (sfs, targetSequence, mapping, parentId) {
var forwardStrand=mapping.isFromForwardStrand$();
Clazz.load('jalview.datamodel.features.SequenceFeatures').sortFeatures$java_util_List$Z(sfs, forwardStrand);
var transferred=false;
for (var sf, $sf = sfs.iterator$(); $sf.hasNext$()&&((sf=($sf.next$())),1);) {
if (this.retainFeature$jalview_datamodel_SequenceFeature$S(sf, parentId)) {
this.transferFeature$jalview_datamodel_SequenceFeature$jalview_datamodel_SequenceI$jalview_util_MapList$Z(sf, targetSequence, mapping, forwardStrand);
transferred=true;
}}
return transferred;
});

Clazz.newMeth(C$, 'retainFeature$jalview_datamodel_SequenceFeature$S', function (sf, accessionId) {
return true;
});

Clazz.newMeth(C$, 'featureMayBelong$jalview_datamodel_SequenceFeature$S', function (sf, identifier) {
var parent=sf.getValue$S("Parent");
if (parent != null  && !parent.toUpperCase$().contains$CharSequence(identifier.toUpperCase$()) ) {
return false;
}return true;
});

Clazz.newMeth(C$, 'getDescription$', function () {
return "Ensembl " + this.getSourceEnsemblType$().getType$() + " sequence with variant features" ;
});

Clazz.newMeth(C$, 'findFeatures$jalview_datamodel_SequenceI$S$S', function (sequence, term, parentId) {
var result=Clazz.new_($I$(14));
var sfs=sequence.getFeatures$().getFeaturesByOntology$SA([term]);
for (var sf, $sf = sfs.iterator$(); $sf.hasNext$()&&((sf=($sf.next$())),1);) {
var parent=sf.getValue$S("Parent");
if (parent != null  && parent.equalsIgnoreCase$S(parentId) ) {
result.add$TE(sf);
}}
return result;
});

Clazz.newMeth(C$, 'isTranscript$S', function (featureType) {
return "NMD_transcript_variant".equals$O(featureType) || $I$(19).getInstance$().isA$S$S(featureType, "transcript") ;
}, 1);
;
(function(){var C$=Clazz.newClass(P$.EnsemblSeqProxy, "EnsemblSeqType", function(){
Clazz.newInstance(this, arguments[0],false,C$);
}, 'Enum');

C$.$clinit$ = function() {Clazz.load(C$, 1);
$vals=Clazz.array(C$,[0]);
Clazz.newEnumConst($vals, C$.c$$S, "GENOMIC", 0, ["genomic"]);
Clazz.newEnumConst($vals, C$.c$$S, "CDNA", 1, ["cdna"]);
Clazz.newEnumConst($vals, C$.c$$S, "CDS", 2, ["cds"]);
Clazz.newEnumConst($vals, C$.c$$S, "PROTEIN", 3, ["protein"]);
}

Clazz.newMeth(C$, '$init0$', function () {
var c;if((c = C$.superclazz) && (c = c.$init0$))c.apply(this);
this.type=null;
}, 1);

Clazz.newMeth(C$, '$init$', function () {
}, 1);

Clazz.newMeth(C$, 'c$$S', function (t) {
C$.$init$.apply(this);
this.type=t;
}, 1);

Clazz.newMeth(C$, 'getType$', function () {
return this.type;
});

Clazz.newMeth(C$);
var $vals=[];
Clazz.newMeth(C$, 'values$', function() { return $vals }, 1);
Clazz.newMeth(C$, 'valueOf$S', function(name) { for (var val in $vals){ if ($vals[val].name == name) return $vals[val]} return null }, 1);
})()
})();
;Clazz.setTVer('3.2.2.04');//Created 2018-08-26 06:33:31 Java2ScriptVisitor version 3.2.2.04 net.sf.j2s.core.jar version 3.2.2.04
